# Design Principles

The following points form the basis for all design decisions made within the
cryptic-net project.

* The UX is aggressively optimized to eliminate manual intervention by users.
  All other concerns are secondary. The concept of "UX" extends beyond GUI
  interfaces, and encompasses all interactions of any sort with a cryptic-net
  process.

* All resources within a cryptic-net are expected to be hosted on hardware owned
  by community members, for example home media servers or gaming rigs. Thus, a
  cryptic-net is fully autonomous.

* Hardware resources are expected to be heterogenous and geographically
  dispersed.

* It is expected that a single host might be a part of multiple, independent
  cryptic networks. These should not conflict with each other, nor share
  resources.

