# Using DNS

Every `cryptic-net daemon` process ships with a DNS server which runs
automatically. This server will listen on port 53 on the VPN IP of that
particular host.

The server will serve requests for `<hostname>.hosts.<domain>` hostnames,
where `<hostname>` is the name of any host in the network, and `<domain`> is the
network's domain name.

If a request for a hostname not within the network's domain is received then the
server will forward the request to a pre-configured public resolver. The set of
public resolvers used can be configured using the
[daemon.yml](creating-a-daemonyml-file.md) file.

This DNS server is an optional feature of cryptic-net, and not required in
general for making use of the network.

## Example

As an example of how to make use of this DNS server, let's say my host's IP on
the network is `10.10.1.1`, and my network's domain is `cool.internal`.
In order to configure the host to use the cryptic-net DNS server for all DNS
requests, I could do something like this:

```
sudo su
echo "nameserver 10.10.1.1" > /etc/resolv.conf
```

From that point, all DNS requests on my host would hit the cryptic-net DNS
server. If I request `my-host.hosts.cool.internal`, it would respond with the
appropriate private IP.

NOTE that configuration of dns resolvers is very OS-specific, even amongst Linux
distributions, so ensure you know how your resolver configuration works before
doing this.
