{

  fetchgit,
  buildEnv,
  minio-client,

}: let

  version = "0.8.0-rc1";

  src = fetchgit {
    name = "garage-v${version}";
    url = "https://git.deuxfleurs.fr/Deuxfleurs/garage.git";
    rev = "2197753dfdb25944e55c25d911ae6d14b8506c4d";
    sha256 = "sha256-Rzwx1/vl3xg5bj4Chxj8VLBZ25zlPawOc+uMl3AHhkw=";
  };

in rec {

  garage = (import "${src}/default.nix") { git_version = version; };

  minioClient = minio-client;

  env = buildEnv {
    name = "cryptic-net-garage";
    paths = [
      garage.pkgs.amd64.release
      minioClient
    ];
  };

}

